XPHASE EQU SI-4+0
YPHASE EQU SI-4+1

ORG 256
 DW 127                 ; constant 127 -> amplitude for sinus table
 DW 3C00H               ; constant 1/128 -> calculating PI/128 for sinus table

 MOV FS,AX
 MOV AL,13H
colors:
 INT 10H
 MOV CH,48
 IMUL DX,BX,64
 MOV AX,1010H
 INT 10H
 INC BL
 JNZ colors

 MOV BH,080H
 PUSH BX
 POP ES
costab:
 FLDPI                  ; PI
 FMUL DWORD [SI]        ; PI/128
 FIMUL WORD [DI]        ; counter*PI/128
 FCOS                   ; COS(counter*PI/128)
 FIMUL WORD [SI]        ; 127*COS(counter*PI/128)
 FISTP WORD [BX+SI]     ; -
 INC BX
 INC BYTE [DI]          ; loop 256x
 JNZ costab             ; BX = cosinus table

 ADD SI,SI
nextframe:
nextpixel:              ; XPhase=0.9, YPhase=0.7
 MOV AX,0CCCDH
 MUL DI
 MOV CX,[FS:46CH]
; AND CX,0FFH
 MOV CH,1
 MOV BL,DH
 MOV DH,DL
 IMUL AX,CX,-128
 MUL DX
 XCHG DH,BL
 IMUL AX,CX,-128
 MUL DX
 MOV DL,BL
 ADD DH,CL

 MOV WORD [XPHASE],37+256*29
 MOV BP,77*77           ; BP:Amplitude*Amplitude=0.3*0.3
 MOV CX,6+256*5         ; CL:XFreq=2*PI*0.023, CH:YFreq=2*PI*0.021
 FLDZ
 FSTP DWORD [SI]        ; f=0, i=0
fori:
;NOT DH
 PUSH DX

 MOV AL,[XPHASE]
 ADD AL,DL
 MUL CL
 MOV BL,AL
 MOV AL,[BX]
 CBW
 ADD AX,54
 XCHG DX,AX
 MOV AL,[YPHASE]
 ADD AL,AH
 MUL CH
 MOV BL,AL
 MOV AL,[BX]
 CBW
 ADD AX,54
 IMUL DX
 IMUL BP
 ADD [SI],DX

 POP AX
 PUSH AX
 MOV BL,AH
 MUL CL
 XCHG AL,BL
 MOV DH,[BX]
 MUL CH
 MOV BL,AL
 MOV DL,[BX]
 MOV [XPHASE],DX
 POP DX

 SHR BP,1
 SHL CX,1
 JNS fori

 MOV AL,[SI+1]
 NEG AL
 JZ .1
 CBW
 MOV [SI],AH
.1:

 MOVSB
 DEC SI
 TEST DI,DI
 JNE nextpixel

 PUSH ES
 POP DS
 CALL BLUR
 CALL BLUR
 PUSH 0A000H
 POP ES
 CALL BLUR
 PUSH DS
 POP ES
 PUSH CS
 POP DS

; IN AL,60H
; DAS
; JC nextframe
 MOV AH,1
 INT 16H
 JZ nextframe

RETN

BLUR:
 MOV CH,0
.8:
 ADD AL,[DI+1]               ; AL contains 0 at start, and last color later
 ADC AH,CH                   ; summing the 4 neighbours
 ADD AL,[DI+320]
 ADC AH,CH
 ADD AL,[DI-320]
 ADC AH,CH
 SHR AX,2                    ; dividing by 4
 STOSB
 TEST DI,DI
 JNZ .8
RETN